ZipUtil (Apache Ant API)
Description: declaration: package: org.apache.tools.zip, class: ZipUtil

Package org.apache.tools.zip

# Class ZipUtil

java.lang.Object
org.apache.tools.zip.ZipUtil

    public abstract class ZipUtil
    extends java.lang.Object

Utility class for handling DOS and Java time conversions.

Since:
  Ant 1.8.1

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `ZipUtil()` |

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static long` | `adjustToLong​(int i)` | Assumes a negative integer really is a positive integer that has wrapped around and re-creates the original value.
  `static long` | `dosToJavaTime​(long dosTime)` | Converts DOS time to Java time (number of milliseconds since epoch).
  `static java.util.Date` | `fromDosTime​(ZipLong zipDosTime)` | Convert a DOS date/time field to a Date object.
  `static byte[]` | `toDosTime​(long t)` | Convert a Date object to a DOS date/time field.
  `static void` | `toDosTime​(long t, byte[] buf, int offset)` | Convert a Date object to a DOS date/time field.
  `static ZipLong` | `toDosTime​(java.util.Date time)` | Convert a Date object to a DOS date/time field.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### ZipUtil

    public ZipUtil()

- ## Method Details

  - ### toDosTime

    public static ZipLong toDosTime​(java.util.Date time)
    Convert a Date object to a DOS date/time field.
    Parameters:
      `time` - the `Date` to convert
    Returns:
      the date as a `ZipLong`

  - ### toDosTime

    public static byte[] toDosTime​(long t)
    Convert a Date object to a DOS date/time field.

    Stolen from InfoZip's `fileio.c`

    Parameters:
      `t` - number of milliseconds since the epoch
    Returns:
      the date as a byte array

  - ### toDosTime

    public static void toDosTime​(long t, byte[] buf, int offset)
    Convert a Date object to a DOS date/time field.

    Stolen from InfoZip's `fileio.c`

    Parameters:
      `t` - number of milliseconds since the epoch
      `buf` - the output buffer
      `offset` - The offset within the output buffer of the first byte to be written. must be non-negative and no larger than `buf.length-4`

  - ### adjustToLong

    public static long adjustToLong​(int i)
    Assumes a negative integer really is a positive integer that has wrapped around and re-creates the original value.

    This methods is no longer used as of Apache Ant 1.9.0

    Parameters:
      `i` - the value to treat as unsigned int.
    Returns:
      the unsigned int as a long.

  - ### fromDosTime

    public static java.util.Date fromDosTime​(ZipLong zipDosTime)
    Convert a DOS date/time field to a Date object.
    Parameters:
      `zipDosTime` - contains the stored DOS time.
    Returns:
      a Date instance corresponding to the given time.

  - ### dosToJavaTime

    public static long dosToJavaTime​(long dosTime)
    Converts DOS time to Java time (number of milliseconds since epoch).
    Parameters:
      `dosTime` - long
    Returns:
      long